package 
{
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.utils.getDefinitionByName;
	
	/**
	 * ...
	 * @author Damian Connolly
	 */
	public class Preloader extends MovieClip 
	{
		/********************************************************************************/
		
		private static const M_STAGE_W:Number = 500.0;
		private static const M_STAGE_H:Number = 400.0;
		
		/********************************************************************************/
		
		private var m_bar:Shape = null;
		
		/********************************************************************************/
		
		public function Preloader() 
		{
			if ( this.stage) 
			{
				this.stage.scaleMode 	= StageScaleMode.NO_SCALE;
				this.stage.align 		= StageAlign.TOP_LEFT;
			}
			this.addEventListener( Event.ENTER_FRAME, _onEnterFrame );
			this.loaderInfo.addEventListener( ProgressEvent.PROGRESS, _onProgress );
			this.loaderInfo.addEventListener( IOErrorEvent.IO_ERROR, _onIOError );
			
			// create our bar
			this.m_bar = new Shape;
			this.m_bar.graphics.beginFill( 0xffffff );
			this.m_bar.graphics.drawRect( 0.0, 0.0, 100, 2.0 );
			this.m_bar.graphics.endFill();
			this.m_bar.x = Preloader.M_STAGE_W * 0.5 - this.m_bar.width * 0.5;
			this.m_bar.y = Preloader.M_STAGE_H * 0.5 - this.m_bar.height * 0.5;
			this.addChild( this.m_bar );
			
			// draw our outline
			this.graphics.lineStyle( 1.0, 0xffffff );
			this.graphics.drawRect( this.m_bar.x - 1.5, this.m_bar.y - 1.5, this.m_bar.width + 3.0, this.m_bar.height + 3.0 );
		}
		
		/********************************************************************************/
		
		private function _onIOError( e:IOErrorEvent ):void 
		{
			trace( "3:IOError: " + e.errorID + ": " + e.text );
		}
		
		private function _onProgress( e:ProgressEvent ):void 
		{
			var pc:Number 		= ( e.bytesLoaded / e.bytesTotal );
			this.m_bar.scaleX	= ( pc < 0.0 ) ? 0.0 : ( pc > 1.0 ) ? 1.0 : pc;
		}
		
		private function _onEnterFrame( e:Event ):void 
		{
			if ( this.currentFrame == this.totalFrames ) 
			{
				this.stop();
				this._onLoadingFinished();
			}
		}
		
		private function _onLoadingFinished():void 
		{
			this.removeEventListener( Event.ENTER_FRAME, this._onEnterFrame );
			this.loaderInfo.removeEventListener( ProgressEvent.PROGRESS, this._onProgress );
			this.loaderInfo.removeEventListener( IOErrorEvent.IO_ERROR, this._onIOError );
			
			// hide loader
			this.removeChild( this.m_bar );
			this.m_bar = null;
			
			this._startup();
		}
		
		private function _startup():void 
		{
			var mainClass:Class = getDefinitionByName( "Main" ) as Class;
			this.stage.addChild( new mainClass() as DisplayObject );
			this.parent.removeChild( this );
		}
		
	}
	
}