package com.divillysausages.connected.assets
{
	import com.divillysausages.ds.asset.EmbeddedAssets;
	
	/**
	 * The resources that we'll use in the game
	 * @author Damian Connolly
	 */
	public class Resources extends EmbeddedAssets 
	{
		
		/*******************************************************************************************/
		
		/**
		 * The game font
		 */
		public static const GAME_FONT:String = "gameFont";
		
		/**
		 * The ds logo image
		 */
		public static const DS_IMAGE:String = "../../../../../assets/ds_logo.png";
		
		/**
		 * The ds sound
		 */
		public static const DS_SOUND:String = "../../../../../assets/ds.mp3";
		
		/**
		 * The game music
		 */
		public static const MUSIC:String = "../../../../../assets/music.mp3";
		
		/*******************************************************************************************/
		
		// the game font
		//[Embed(	source = "../../../../../assets/pf_ronda_seven.ttf", 
		[Embed(	source = "../../../../../assets/champagne.ttf", 
		//[Embed(	systemFont = "Trebuchet Ms", 
				fontName = "gameFont", 
				mimeType = "application/x-font", 
				fontWeight = "normal", 
				fontStyle = "normal", 
				unicodeRange = "englishRange", 
				advancedAntiAliasing = "true", 
				embedAsCFF="false")]
		public var font:Class;
		
		// the ds logo image
		[Embed(source = "../../../../../assets/ds_logo.png")]
		public var dsImage:Class;
		
		// the ds sound
		[Embed(source = "../../../../../assets/ds.mp3", mimeType = "audio/mpeg")]
		public var dsSound:Class;
		
		// the game music
		[Embed(source = "../../../../../assets/music.mp3", mimeType = "audio/mpeg")]
		public var musicSound:Class;
		
	}

}