package com.divillysausages.connected.logic 
{
	import com.divillysausages.ds.core.IUpdateObj;
	import com.divillysausages.ds.DS;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Shape;
	import flash.display.Sprite;
	import org.osflash.signals.Signal;
	
	/**
	 * ...
	 * @author Damian Connolly
	 */
	public class ScreenFade extends Sprite implements IUpdateObj
	{
		
		/*******************************************************************************************/
		
		/**
		 * The signal dispatched when we're finished fading; it should take no params
		 */
		public var signalOnFinished:Signal = null;
		
		/*******************************************************************************************/
		
		private var m_currTime:Number 				= 0.0;
		private var m_time:Number					= 0.0;
		private var m_hasDispatchedSignal:Boolean	= false;
		
		/*******************************************************************************************/
		
		public function get active():Boolean { return ( this.parent != null ); }
		
		/*******************************************************************************************/
		
		public function ScreenFade( colour:uint, time:Number ) 
		{
			// create our graphics
			var bmd:BitmapData 	= new BitmapData( 10, 10, false, colour );
			var b:Bitmap		= new Bitmap( bmd );
			b.width				= DS.stage.stageWidth;
			b.height			= DS.stage.stageHeight;
			this.addChild( b );
			
			// set our time
			this.m_time = time;
			
			// create our signal
			this.signalOnFinished = new Signal;
			
			// add to the update
			DS.addToUpdate( this );
		}
		
		public function destroy():void
		{
			// update
			DS.removeFromUpdate( this );
			
			// grpahics
			if ( this.parent != null )
				this.parent.removeChild( this );
				
			// signals
			this.signalOnFinished.removeAll();
			
			// null our properties
			this.signalOnFinished = null;
		}
		
		public function show():void
		{
			this.alpha 					= 0.0;
			this.m_currTime				= 0.0;
			this.m_hasDispatchedSignal	= false;
			DS.stage.addChild( this );
		}
		
		public function hide():void
		{
			if ( this.parent != null )
				this.parent.removeChild( this );
		}
		
		public function update( dt:Number ):void
		{
			this.m_currTime += dt;
			if ( this.m_currTime > this.m_time )
				this.m_currTime = this.m_time;
				
			// get our alpha pc
			this.alpha = ( this.m_currTime / this.m_time );
			if ( this.alpha >= 1.0 && !this.m_hasDispatchedSignal )
			{
				this.signalOnFinished.dispatch();
				this.m_hasDispatchedSignal = true;
			}
		}
		
	}

}