package com.divillysausages.connected.logic 
{
	import com.divillysausages.ds.core.IUpdateObj;
	import com.divillysausages.ds.DS;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Shape;
	import flash.display.Sprite;
	
	/**
	 * ...
	 * @author Damian Connolly
	 */
	public class ScreenFlash extends Sprite implements IUpdateObj
	{
		
		/*******************************************************************************************/
		
		private var m_currTime:Number 	= 0.0;
		private var m_time:Number		= 0.0;
		private var m_startAlpha:Number	= 0.8;
		
		/*******************************************************************************************/
		
		public function get active():Boolean { return ( this.parent != null ); }
		
		/*******************************************************************************************/
		
		public function ScreenFlash( colour:uint, time:Number ) 
		{
			// create our graphics
			var bmd:BitmapData 	= new BitmapData( 10, 10, false, colour );
			var b:Bitmap		= new Bitmap( bmd );
			b.width				= DS.stage.stageWidth;
			b.height			= DS.stage.stageHeight;
			this.addChild( b );
			
			// set our time
			this.m_time = time;
			
			// add to the update
			DS.addToUpdate( this );
		}
		
		public function destroy():void
		{
			DS.removeFromUpdate( this );
			if ( this.parent != null )
				this.parent.removeChild( this );
		}
		
		public function show():void
		{
			this.alpha 		= this.m_startAlpha;
			this.m_currTime	= 0.0;
			DS.stage.addChild( this );
		}
		
		public function update( dt:Number ):void
		{
			this.m_currTime += dt;
			if ( this.m_currTime > this.m_time )
				this.m_currTime = this.m_time;
				
			// get our alpha pc
			this.alpha = this.m_startAlpha * ( 1.0 - ( this.m_currTime / this.m_time ) );
			if ( this.alpha <= 0.0 )
				this.parent.removeChild( this );
		}
		
	}

}